extends Area2D

signal dead
export (int) var SPEED
export (PackedScene) var Laser
var screensize
var fire_speed = 15
var health = 400
var hit_timer = 1000
var can_shoot = true
var health_multi = 1

func _on_Visibility_screen_exited():
	prints("bye-bye, bad bad")
	queue_free()

func _ready():
	connect("area_entered", self, "hit")
	$Rotatable.rotation_degrees = -90


func hit(who):
	health -= 10/health_multi
	$AnimatedSprite.frame = 1
	hit_timer = 0

var velocity = Vector2()

func _process(delta):
	if health <= 0:
		emit_signal("dead", 200)
		queue_free()

	$Rotatable.rotation_degrees += delta*fire_speed

	if ($Rotatable.rotation_degrees > 45 && $Rotatable.rotation_degrees < 55 && can_shoot == true):
		can_shoot = false
		shoot()

	elif ($Rotatable.rotation_degrees > 135 && $Rotatable.rotation_degrees < 145 && can_shoot == true):
		can_shoot = false
		shoot()

	elif ($Rotatable.rotation_degrees > 225 && $Rotatable.rotation_degrees < 235 && can_shoot == true):
		can_shoot = false
		shoot()

	elif ($Rotatable.rotation_degrees > 315 && $Rotatable.rotation_degrees < 325 && can_shoot == true):
		can_shoot = false
		shoot()

	elif ( $Rotatable.rotation_degrees > 55 && $Rotatable.rotation_degrees < 60):
		can_shoot = true
	elif ( $Rotatable.rotation_degrees > 145 && $Rotatable.rotation_degrees < 150):
		can_shoot = true
	elif ( $Rotatable.rotation_degrees > 235 && $Rotatable.rotation_degrees < 235):
		can_shoot = true
	elif ( $Rotatable.rotation_degrees > 325 && $Rotatable.rotation_degrees < 325):
		can_shoot = true

	if $Rotatable.rotation_degrees > 360:
		$Rotatable.rotation_degrees = 0
		can_shoot = true


	if hit_timer < 0.15:
		hit_timer += delta
		if health < 100:
			fire_speed = 75
	elif hit_timer < 0.25:
		hit_timer += delta
		velocity.x -= 1
	else:
		velocity.x -= 1
		$AnimatedSprite.frame = 0

	if velocity.length() > 0:
		velocity = velocity.normalized() * SPEED

	var health_bar = Vector2(((health * 3.75) - 750), -1100)
	$Line2D.set_point_position( 1, health_bar )

	position += velocity * delta

func shoot():
	var laser = Laser.instance()
	get_node("../").add_child(laser)
	laser.friendly_laser = false
	laser.rotation_degrees = 180
	laser.position.y = position.y - 10
	laser.position.x = position.x - 170